<?php

namespace STM\DB\SQL;

use \Exception;

/**
 * Test class for RowsLimit.
 * Generated by PHPUnit on 2012-02-07 at 10:56:58.
 * @group database
 */
class RowsLimitTest extends \PHPUnit_Framework_TestCase {

    /** @var RowsLimit */
    private $rows_limit;

    protected function setUp() {
        $this->rows_limit = new RowsLimit();
    }

    public function testSet() {
        $this->assert_bad_values(0, 5);
        $this->assert_bad_values(1, -1);
        $this->assert_bad_values(-5, -10);
    }
    
    public function testGetters() {
        $this->assert_rows_limits(1, 0);
        $this->assert_rows_limits(5, 1);
        $this->assert_rows_limits(10, 2);
    }

    private function assert_rows_limits($max, $offset) {        
        $this->rows_limit->set($max, $offset);
        parent::assertEquals($this->rows_limit->getMaxRows(), $max);
        parent::assertEquals($this->rows_limit->getOffset(), $offset);
    }
    
    private function assert_bad_values($max, $offset) {
        try {
            $this->rows_limit->set($max, $offset);
            parent::fail('This test did not fail as expected');
        } catch (Exception $e) {
            parent::assertTrue(is_string($e->getMessage()));
        }
    }
}

?>
